/*
 * SWE619 
 * ASSIGNMENT 10
 * NAN LI
 * PointTest
 * 
 */

package assignment10;


import static org.junit.Assert.assertEquals;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;

public class PointTest {
	Point2 p2;
	Point3 p3,p1;

	@Before
	public void setUp() throws Exception {
	}

	@After
	public void tearDown() throws Exception {
		p2 = null;
		p3 = null;
	}
	//Test for Reflexivity
	@Test
	public void Test1(){
		p2 = new Point2(1,2);
		p1 = new Point3(1,2,4);
		assertEquals(true,p2.equals(p2));
		assertEquals(true,p1.equals(p1));
	}
	//Test for Symmetry
	@Test
	public void Test2(){
		p1 = new Point3(1,2,4);
		p2 = new Point2(1,2);
		p3 = new Point3(1,2,3);
		
		assertEquals(false,p3.equals(p1));
		assertEquals(false,p1.equals(p3));
		assertEquals(true,p1.equals(p2));
		assertEquals(true,p2.equals(p1));
	}
	//Test for Transitivity
	//p1 is equal to p2 and p2 is equal to p3 but p1 is not equalt to p3
	@Test
	public void Test3(){
		p1 = new Point3(1,2,4);
		p2 = new Point2(1,2);
		p3 = new Point3(1,2,3);
		
		assertEquals(true,p1.equals(p2));
		assertEquals(true,p2.equals(p3));	
		assertEquals(false,p1.equals(p3));
	}
	//Test for Consistency
	@Test
	public void Test4(){
		p2 = new Point2(1,2);
		p1 = new Point3(1,2,4);
		assertEquals(true,p2.equals(p2));
		assertEquals(true,p1.equals(p1));
		assertEquals(true,p2.equals(p2));
		assertEquals(true,p1.equals(p1));
		assertEquals(true,p2.equals(p2));
		assertEquals(true,p1.equals(p1));
	}
	//Test for Non-nullity
	@Test
	public void Test5(){
		p2 = new Point2(1,2);
		p1 = new Point3(1,2,4);
		assertEquals(false,p2.equals(null));
		assertEquals(false,p1.equals(null));
	}
	//Test for breaking hash code
	//p1 is equal to p2 but they produce different hash code
	@Test
	public void Test6(){
		p2 = new Point2(1,2);
		p1 = new Point3(1,2,4);
		assertEquals(true,p1.equals(p2));
		assertEquals(p1.hashCode(),p2.hashCode());
	}
	
}
